/* inverse rectangle */
#define inverserectangle(w,xa,xb) InvertGrayRect(xa,w,xb,w+10)
void SetBackground (short x, short y, void *addr);

typedef struct
{
	unsigned char left;
	unsigned char right;
	unsigned char up;
	unsigned char down;
	unsigned char esc;
	unsigned char confirm;
} Keystat;

Keystat* KeysCheck(Keystat* keystat)
{
memset(keystat,0,sizeof(Keystat));

	if(_keytest(RR_ESC)) keystat->esc = 1;
	else if(_keytest(RR_UP)) keystat->up = 1;
	else if(_keytest(RR_DOWN)) keystat->down = 1;
	else if(_keytest(RR_LEFT)) keystat->left = 1;
	else if(_keytest(RR_RIGHT)) keystat->right = 1;
	else if(_keytest(RR_ENTER)||_keytest(RR_HAND)||
	 _keytest(RR_F1)||_keytest(RR_2ND)) keystat->confirm = 1;

return keystat;
}

/* Function for displaying and returning selected menu option */
int
domenu (char x, char y, char setmenu[], char comps, short choice)
{
Keystat keystat;
  int w = 0, changed = 1, i, j, exit = 0;
  int total = comps;
  int totalplace = 0;
  FontSetSys (F_6x8);
  if (comps > 7)
    comps = 7;
  w = choice;
  ClearGrayScreen ();
  SetBackground (display_offsetx, display_offsety, GetPlane (0));
  while (exit == 0)
    {
      if (changed == 1)
	{
	  if (totalplace < 0)
	    totalplace = 0;
	  comps = total - totalplace;
	  if (comps > 7)
	    comps = 7;
	  for (i = totalplace, j = 0; i < comps + totalplace; i++, j++)
	    {
	      DrawGrayStr (x, 10 * j + y, setmenu + 9 * i, A_NORMAL);
	    }
	  inverserectangle (10 * w + y - 1, x - 1, 145);
	  changed = 0;
	}
KeysCheck(&keystat);
      if (keystat.up || keystat.left)
	{
		FAT_AllKeysReleased();	
	  inverserectangle (10 * w + y - 1, x - 1, 145);
	  if (w == 0)
	    {
	      if (totalplace > 7)
		{
		  totalplace -= 7;
		  w = 7;
		}
	      else
		{
		  //w = comps;
		}
	    }

	  if (w > 0)
	    w--;
	  changed = 1;
	}
      else if (keystat.down || keystat.right)
	{
		FAT_AllKeysReleased();	
	  inverserectangle (10 * w + y - 1, x - 1, 145);
	  if (w == comps - 1)
	    {
	      if (total > totalplace + 7)
		{
		  totalplace += 7;
		}
	      else
		totalplace = 0;
	      w = -1;
	    }

	  if (w < comps - 1)
	    w++;
	  if (w == -1)
	    w = 0;
	  changed = 1;
	}
      else if (keystat.esc)
	{
	FAT_AllKeysReleased();
	  exit++;
	}
      else if (keystat.confirm)
	{
	FAT_AllKeysReleased();
	  return w + totalplace;
	}


    }
  return -1;
}
